// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	tharsis "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// Group is an autogenerated mock type for the Group type
type Group struct {
	mock.Mock
}

// CreateGroup provides a mock function with given fields: ctx, input
func (_m *Group) CreateGroup(ctx context.Context, input *types.CreateGroupInput) (*types.Group, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Group
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateGroupInput) (*types.Group, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateGroupInput) *types.Group); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Group)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateGroupInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteGroup provides a mock function with given fields: ctx, input
func (_m *Group) DeleteGroup(ctx context.Context, input *types.DeleteGroupInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteGroupInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetGroup provides a mock function with given fields: ctx, input
func (_m *Group) GetGroup(ctx context.Context, input *types.GetGroupInput) (*types.Group, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Group
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetGroupInput) (*types.Group, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetGroupInput) *types.Group); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Group)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetGroupInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetGroupPaginator provides a mock function with given fields: ctx, input
func (_m *Group) GetGroupPaginator(ctx context.Context, input *types.GetGroupsInput) (*tharsis.GroupPaginator, error) {
	ret := _m.Called(ctx, input)

	var r0 *tharsis.GroupPaginator
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetGroupsInput) (*tharsis.GroupPaginator, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetGroupsInput) *tharsis.GroupPaginator); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*tharsis.GroupPaginator)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetGroupsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetGroups provides a mock function with given fields: ctx, input
func (_m *Group) GetGroups(ctx context.Context, input *types.GetGroupsInput) (*types.GetGroupsOutput, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.GetGroupsOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetGroupsInput) (*types.GetGroupsOutput, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetGroupsInput) *types.GetGroupsOutput); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.GetGroupsOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetGroupsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MigrateGroup provides a mock function with given fields: ctx, input
func (_m *Group) MigrateGroup(ctx context.Context, input *types.MigrateGroupInput) (*types.Group, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Group
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.MigrateGroupInput) (*types.Group, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.MigrateGroupInput) *types.Group); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Group)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.MigrateGroupInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateGroup provides a mock function with given fields: ctx, input
func (_m *Group) UpdateGroup(ctx context.Context, input *types.UpdateGroupInput) (*types.Group, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Group
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateGroupInput) (*types.Group, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateGroupInput) *types.Group); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Group)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateGroupInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewGroup interface {
	mock.TestingT
	Cleanup(func())
}

// NewGroup creates a new instance of Group. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewGroup(t mockConstructorTestingTNewGroup) *Group {
	mock := &Group{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
